<template>
  <div class="m-compact-text">
    <template v-if="isNeededCompact">
      <div
        class="m-compact-text__body"
        :class="[bodyClass]"
        v-html="isShow ? deploedText : compactedText"
      />
      <div
        class="m-compact-text__action"
        v-text="isShow ? 'Свернуть' : 'Читать дальше'"
        @click="isShow = !isShow"
      />
    </template>
    <template v-else>
      <div :class="[bodyClass]" v-html="deploedText" />
    </template>
  </div>
</template>

<script>
import marked from "marked";
import sanitizeHtml from "sanitize-html";

export default {
  name: "CompactText",

  props: {
    text: {
      type: String,
      required: true,
    },

    maxLength: {
      type: Number,
      default: 200,
    },

    bodyClass: {
      type: String,
      default: "",
    },

    markdown: {
      type: Boolean,
      required: false,
      default: false,
    },

    allowedTags: {
      type: Array,
      required: false,
      default: () => ["p", "a", "br"],
    },
  },

  data() {
    return {
      isShow: false,
    };
  },

  methods: {
    mardownText(text) {
      if (this.markdown) {
        marked.setOptions({ breaks: true });
        return marked(text);
      }
      return text;
    },

    sanitizeHtml(text) {
      return sanitizeHtml(text, {
        allowedTags: this.allowedTags,
      });
    },
  },

  computed: {
    isNeededCompact() {
      return this.text.length > this.maxLength;
    },

    compactedText() {
      return this.sanitizeHtml(
        this.mardownText(this.text.substring(0, this.maxLength) + "...")
      );
    },

    deploedText() {
      return this.sanitizeHtml(this.mardownText(this.text));
    },
  },
};
</script>

<style lang="scss" scoped>
@import "../../assets/scss/variables.scss";

.m-compact-text {
  &__action {
    display: inline-block;
    cursor: pointer;
    color: $white60;
    margin: 2px 0;
    transition: color 0.2s ease-in-out;

    &:hover {
      color: $white;
    }
  }
}
</style>
